#ifndef CORE_SPIN_LOCK_H
#define CORE_SPIN_LOCK_H

#include <stdatomic.h>

typedef struct {
    atomic_bool lock;
} CoreSpinLock;

void coreInitSpinLock(CoreSpinLock* l);
void coreLockSpinLock(CoreSpinLock* l);
void coreUnlockSpinLock(CoreSpinLock* l);

#ifdef IMPORT_CORE
#define SpinLock CoreSpinLock
#define initSpinLock coreInitSpinLock
#define lockSpinLock coreLockSpinLock
#define unlockSpinLock coreUnlockSpinLock
#endif

#endif
