#define IMPORT_CORE
#include "core/Plane.h"

#include "core/Generic.h"

void initPlane(Plane* p, const Vector3* a, const Vector3* b, const Vector3* c) {
    cross(&p->abc, sub(b, a), sub(c, a));
    normalize(&p->abc);
    p->d = -dot(&p->abc, b);
}

float signedDistance(const Plane* p, const Vector3* v) {
    return dot(&p->abc, v) + p->d;
}
